%{!?ruby_sitelibdir: %define ruby_sitelibdir %(PATH=/opt/puppet/bin:$PATH ruby -e "puts RbConfig::CONFIG['sitelibdir']")}

%global p_vendor       pe
%global _name          facter
%global realversion    2.3.0.0
%global rpmversion     2.3.0.0

%if "%{_os}" == "aix"
  %{!?_aix: %global _aix 1}
%endif

%if 0%{?suse_version}
  %global which_package util-linux
%endif

%if 0%{?rhel}
  %global which_package which
%endif

%ifarch %ix86 x86_64 ia64
    %{!?_utilsarch: %global _utilsarch 1}
%endif

%if 0%{?p_vendor:1}
    %global name_prefix      %{p_vendor}-

    # Override the _prefix last, so we can get the _real_* locations.
    %{!?_orig_prefix:     %global _orig_prefix     %{_prefix}}
    %global               _prefix /opt/puppet
    %global               _mandir %{_prefix}/share/man
%endif

%if 0%{?_aix}
  %global               _symlinkdir /usr/bin
%else
  %global               _symlinkdir /usr/local/bin
%endif

%define ruby          %{_bindir}/ruby

Summary:        Ruby module for collecting simple facts about a host operating system
Name:           %{?name_prefix}%{_name}
Version:        %{rpmversion}
Release:        1.pe%{?dist}
Vendor:         Puppet Labs
License:        PL Commercial
Group:          System Environment/Base
URL:            http://www.puppetlabs.com/puppet/related-projects/%{name}
# Note this     URL will only be valid at official tags from Puppet Labs
Source0:        http://puppetlabs.com/downloads/%{name}/%{name}-%{realversion}.tar.gz

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

# dmidecode is not available on all arches and rhel4
%if 0%{?_utilsarch} && 0%{?rhel} >= 5
Requires:       dmidecode
%endif

# pciutils is not available on all arches
%if 0%{?_utilsarch}
Requires:       pciutils
%endif

# we now vendor virt-what for rhel4, rhel5, rhel6, and sles.
# still not available for AIX
%if "%{?_os}" != "aix"
Requires:       %{?name_prefix}virt-what
%endif

Requires:       %{?name_prefix}ruby
BuildRequires:  %{?name_prefix}ruby

# install.rb requires which to find gzip to install manpages (util-linux provides which on sles)
%if 0%{?which_package:1}
BuildRequires:  %{which_package}
Requires:       %{which_package}
%endif

%if "%{?_os}" != "aix"
BuildRequires:  gzip
%endif

Provides:       %{name} = %{version}-%{release}

%description
Ruby module for collecting simple facts about a host Operating
system. Some of the facts are preconfigured, such as the hostname and the
operating system. Additional facts can be added through simple Ruby scripts

%prep
%setup -q  -n %{name}-%{realversion}

%build

%install
rm -rf %{buildroot}
%{ruby} install.rb --destdir=%{buildroot} --quick --man --mandir=%{_mandir}
for file in solaris \
            ips \
            debian \
            osx \
            redhat \
            build_defaults.yaml \
            project_data.yaml ; do
  rm -rf %{buildroot}%{_datadir}/%{_name}/ext/$file ;
done

mkdir -p %{buildroot}%{_symlinkdir}
ln -sf %{_prefix}/bin/facter %{buildroot}%{_symlinkdir}/facter

%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%{_bindir}/facter
%{_symlinkdir}/facter
%{ruby_sitelibdir}/facter.rb
%{ruby_sitelibdir}/facter
%{_mandir}/man8/facter.8.gz
%doc README.md


%changelog
* Tue Nov 25 2014 Puppet Labs Release <info@puppetlabs.com> -  2.3.0.0-1.pe
- Build for 2.3.0.0

* Tue May 14 2013 Moses Mendoza <moses@puppetlabs.com> - 1.7.1-2.pe
- virt-what doesn't exist on sles, so don't require it there

* Mon May 13 2013 Moses Mendoza <moses@puppetlabs.com> - 1.7.1-1.pe
- Update to Facter 1.7.1

* Fri May 3 2013 Branan Purvine-Riley <branan@puppetlabs.com> - 1.7.0-1.pe
- Update to Facter 1.7.0

* Wed Jan 30 2013 Matthaus Owens <matthaus@puppetlabs.com> - 1.6.17-1.pe
- Update to Facter 1.6.17

* Thu Sep 06 2012 Moses Mendoza <moses@puppetlabs.com> - 1.6.10-1.pe
- Update to Facter 1.6.10

* Mon Mar 26 2012 Matthaus Litteken <matthaus@puppetlabs.com> - 1.6.7-1.pe
- Update to Facter 1.6.7

* Thu Mar 1 2012 Matthaus Litteken <matthaus@puppetlabs.com> - 1.6.6-1.pe
- Update to Facter 1.6.6

* Fri Feb 17 2012 Matthaus Litteken <matthaus@puppetlabs.com> - 1.6.4-3.pe
- dmidecode should only be a requirement if not on el4

* Thu Feb 09 2012 Matthaus Litteken <matthaus@puppetlabs.com> - 1.6.4-2.pe
- Add pciutils, dmidecode as dependencies.

* Tue Jan 03 2012 Michael Stahnke <stahnma@puppetlabs.com> - 1.6.2-2.pe
- Rebase 1.6.4

* Mon Oct 10 2011 Michael Stahnke <stahnma@puppetlabs.com> - 1.6.2-1.pe
- Rebase to 1.6.2

* Thu Aug 18 2011 Matthaus Litteken <matthaus@puppetlabs.com> - 1.6.0-2.pe
- Bumped release to 2 for PE 1.2

* Thu Jul 21 2011 Michael Stahnke <stahnma@puppetlabs.com> - 1.6.0-1.pe
- Update to 1.6.0

* Sat Aug 28 2010 Todd Zullinger <tmz@pobox.com> - 1.5.8-1
- Update to 1.5.8

* Fri Sep 25 2009 Todd Zullinger <tmz@pobox.com> - 1.5.7-1
- Update to 1.5.7
- Update #508037 patch from upstream ticket

* Wed Aug 12 2009 Jeroen van Meeuwen <j.van.meeuwen@ogd.nl> - 1.5.5-3
- Fix #508037 or upstream #2355

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Fri May 22 2009 Todd Zullinger <tmz@pobox.com> - 1.5.5-1
- Update to 1.5.5
- Drop upstreamed libperms patch

* Sat Feb 28 2009 Todd Zullinger <tmz@pobox.com> - 1.5.4-1
- New version
- Use upstream install script

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.5.2-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Tue Sep 09 2008 Todd Zullinger <tmz@pobox.com> - 1.5.2-1
- New version
- Simplify spec file checking for Fedora and RHEL versions

* Mon Sep  8 2008 David Lutterkort <dlutter@redhat.com> - 1.5.1-1
- New version

* Thu Jul 17 2008 David Lutterkort <dlutter@redhat.com> - 1.5.0-3
- Change 'mkdir' in install to 'mkdir -p'

* Thu Jul 17 2008 David Lutterkort <dlutter@redhat.com> - 1.5.0-2
- Remove files that were listed twice in files section

* Mon May 19 2008 James Turnbull <james@lovedthanlosty.net> - 1.5.0-1
- New version
- Added util and plist files

* Mon Sep 24 2007 David Lutterkort <dlutter@redhat.com> - 1.3.8-1
- Update license tag
- Copy all of lib/ into ruby_sitelibdir

* Thu Mar 29 2007 David Lutterkort <dlutter@redhat.com> - 1.3.7-1
- New version

* Fri Jan 19 2007 David Lutterkort <dlutter@redhat.com> - 1.3.6-1
- New version

* Thu Jan 18 2007 David Lutterkort <dlutter@redhat.com> - 1.3.5-3
- require which; facter is very unhappy without it

* Mon Nov 20 2006 David Lutterkort <dlutter@redhat.com> - 1.3.5-2
- Make require ruby(abi) and buildarch: noarch conditional for fedora 5 or
  later to allow building on older fedora releases

* Tue Oct 10 2006 David Lutterkort <dlutter@redhat.com> - 1.3.5-1
- New version

* Tue Sep 26 2006 David Lutterkort <dlutter@redhat.com> - 1.3.4-1
- New version

* Wed Sep 13 2006 David Lutterkort <dlutter@redhat.com> - 1.3.3-2
- Rebuilt for FC6

* Wed Jun 28 2006 David Lutterkort <dlutter@redhat.com> - 1.3.3-1
- Rebuilt

* Fri Jun 19 2006 Luke Kanies <luke@madstop.com> - 1.3.0-1
- Fixed spec file to work again with the extra memory and processor files.
- Require ruby(abi). Build as noarch

* Fri Jun 9 2006 Luke Kanies <luke@madstop.com> - 1.3.0-1
- Added memory.rb and processor.rb

* Mon Apr 17 2006 David Lutterkort <dlutter@redhat.com> - 1.1.4-4
- Rebuilt with changed upstream tarball

* Tue Mar 21 2006 David Lutterkort <dlutter@redhat.com> - 1.1.4-3
- Do not rely on install.rb, it will be deleted upstream

* Mon Mar 13 2006 David Lutterkort <dlutter@redhat.com> - 1.1.4-2
- Commented out noarch; requires fix for bz184199

* Mon Mar  6 2006 David Lutterkort <dlutter@redhat.com> - 1.1.4-1
- Removed unused macros

* Mon Feb  6 2006 David Lutterkort <dlutter@redhat.com> - 1.1.1-2
- Fix BuildRoot. Add dist to release tag

* Wed Jan 11 2006 David Lutterkort <dlutter@redhat.com> - 1.1.1-1
- Initial build.
